<template>
  <div>
    <div class="content-header">
      <div class="container-fluid">
        <div class="row mb-2">
          <div class="col-sm-6">
            <h1 class="m-0 text-dark">{{ dashboardHeading }}</h1>
          </div>
          <div class="col-sm-6">
            <ol class="breadcrumb float-sm-right">
              <li class="breadcrumb-item">
                <a href="#">Home</a>
              </li>
              <li class="breadcrumb-item active">{{ dashboardHeading }}</li>
            </ol>
          </div>
        </div>
      </div>
    </div>

    <!-- Main content -->
    <section class="content">
      <div class="container-fluid">
        <!-- Small boxes (Stat box) -->
        <div class="row mx-1">
          <div class="col-lg-3 col-6">
            <!-- small box -->
            <div class="small-box bg-info">
              <div class="inner">
                <h3>{{ totalClients }}</h3>

                <p>Total Clients</p>
              </div>
              <div class="icon">
                <i class="ion ion-person-add"></i>
              </div>
            </div>
          </div>
          <div class="col-lg-3 col-6">
            <div class="small-box bg-success">
              <div class="inner">
                <h3>{{ totalClientsLastMonth }}</h3>

                <p>Clients Last Month</p>
              </div>
              <div class="icon">
                <i class="ion ion-stats-bars"></i>
              </div>
            </div>
          </div>
        </div>
      </div>
    </section>
    <section class="mx-3">
      <v-expansion-panels multiple>
        <v-expansion-panel>
          <v-expansion-panel-header>Clients</v-expansion-panel-header>
          <v-expansion-panel-content>
            <div v-if="trainersClients.length > 0">
              <v-card>
                <v-card-title>
                  Clients Table
                  <v-spacer></v-spacer>
                  <v-text-field
                    v-model="search"
                    append-icon="mdi-magnify"
                    label="Search"
                    single-line
                    hide-details
                  ></v-text-field>
                </v-card-title>
              </v-card>
              <v-data-table
                :search="search"
                id="client-table"
                :items="trainersClients"
                :headers="headers"
                :item-class="itemRowBackground"
              ></v-data-table>
            </div>
            <div v-else>
              <h1>No Clients found</h1>
            </div>
          </v-expansion-panel-content>
        </v-expansion-panel>
        <v-expansion-panel>
          <v-expansion-panel-header> Bookings </v-expansion-panel-header>
          <v-expansion-panel-content>
            <Bookings @onNewBooking="populateClients"></Bookings>
          </v-expansion-panel-content>
        </v-expansion-panel>
      </v-expansion-panels>
    </section>
    <!-- /.content -->
  </div>
</template>

<script>
import trainer from "../../controllers/trainer.controller";
import Bookings from "../../components/Booking/Bookings";
import moment from "moment";
export default {
  name: "Dashboard",
  components: { Bookings },
  props: ["user"],
  computed: {
    dashboardHeading() {
      return this.user.role === "Admin"
        ? "Admin Dashboard"
        : this.user.role === "Trainer"
        ? "Trainer Dashboard"
        : "Client Dashboard";
    },
    totalClients() {
      return this.trainersClients.length;
    },
    totalClientsLastMonth() {
      const dateMonthAgo = moment()
        .subtract(1, "month")
        .format()
        .substring(0, 10);

      const currentDate = moment().format().substring(0, 10);
      return this.trainersClients.filter(
        (client) =>
          client.createdAt.substring(0, 10) <= currentDate &&
          client.createdAt.substring(0, 10) >= dateMonthAgo
      ).length;
    },
  },
  data: function () {
    return {
      trainersClients: [],
      search: "",
      headers: [
        { text: "First name", value: "firstName" },
        { text: "Last name", value: "lastName" },
        { text: "Email", value: "email" },
        { text: "DOB", value: "dob" },
        { text: "Phone", value: "phone" },
        { text: "Address", value: "address" },
        { text: "Postal code", value: "postalCode" },
        { text: "Session", value: "sessions" },
      ],
    };
  },
  methods: {
    itemRowBackground: function (client) {
      const sessions = client.sessions;
      if (sessions >= 5) {
        return "green";
      } else if (sessions < 5 && sessions > 1) {
        return "blue";
      } else if (sessions == 1) {
        return "yellow";
      } else {
        return "red";
      }
    },
    async populateClients() {
      const res = await trainer.getTrainersClients(this.user.trainerId);
      if (res) {
        this.trainersClients = res
        this.trainersClients.forEach((client) => {
          client.dob = client.dob.substring(0, 10);
        });
      }
    },
  },
  async mounted() {
    this.populateClients();
  },
};
</script>

<style>
.green {
  background-color: #28a745;
  color: rgb(255, 255, 255);
}
.blue {
  background-color: #17a2b8;
  color: rgb(255, 255, 255);
}
.yellow {
  background-color: #ffc107;
}
.red {
  background-color: #dc3545;
  color: rgb(255, 255, 255);
}
.red:hover {
  background-color: #a8414b !important;
}
.green:hover {
  background-color: #46af5e !important;
}
.blue:hover {
  background-color: #3fc4d8 !important;
}
.yellow:hover {
  background-color: #ffd044 !important;
}
</style>
